﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Linq;
using System.Collections;

public partial class RadGridExcelLikeFilteringHeight : System.Web.UI.Page
{
    private class DataRowComparer : IEqualityComparer<DataRow>
    {
        private string dataField;
        public DataRowComparer(string dataField)
        {
            this.dataField = dataField;
        }
        public bool Equals(DataRow x, DataRow y)
        {
            return x[dataField].ToString() == y[dataField].ToString();
        }
        public int GetHashCode(DataRow dataRow)
        {
            return dataRow[dataField].GetHashCode();
        }
    }
    protected void Page_PreRenderComplete(object sender, EventArgs e)
    {
        RadContextMenu menu = RadGrid1.HeaderContextMenu;
        string[] valuesToHide = { "GroupBy", "UnGroupBy", "topGroupSeperator",
                                      "bottomGroupSeperator", "SortAsc", "SortDesc",
                                      "SortNone"};
        foreach (RadMenuItem item in menu.Items)
        {
            if (valuesToHide.Contains(item.Value))
            {
                item.Visible = false;
            }
        }
    }
    protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = GetGridSource();
    }
    private DataTable GetGridSource()
    {
        DataTable dataTable = new DataTable();

        DataColumn column = new DataColumn();
        column.DataType = Type.GetType("System.Int32");
        column.ColumnName = "OrderID";
        dataTable.Columns.Add(column);

        column = new DataColumn();
        column.DataType = Type.GetType("System.DateTime");
        column.ColumnName = "OrderDate";
        dataTable.Columns.Add(column);

        column = new DataColumn();
        column.DataType = Type.GetType("System.Decimal");
        column.ColumnName = "Freight";
        dataTable.Columns.Add(column);

        column = new DataColumn();
        column.DataType = Type.GetType("System.String");
        column.ColumnName = "ShipName";
        dataTable.Columns.Add(column);

        column = new DataColumn();
        column.DataType = Type.GetType("System.String");
        column.ColumnName = "ShipCountry";
        dataTable.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = dataTable.Columns["OrderID"];
        dataTable.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i <= 80; i++)
        {
            DataRow row = dataTable.NewRow();
            row["OrderID"] = i + 1;
            row["OrderDate"] = DateTime.Now;
            row["Freight"] = (i + 1) + (i + 1) * 0.1 + (i + 1) * 0.01;
            row["ShipName"] = "Name " + (i % 6 + 1);
            row["ShipCountry"] = "Country " + (i % 9 + 1);

            dataTable.Rows.Add(row);
        }

        return dataTable;
    }
    private DataTable GetListBoxSource(string dataField)
    {
        DataTable table = GetGridSource().Clone();
        table.Rows.Clear();
        GetGridSource().Rows.Cast<DataRow>().Distinct<DataRow>(new DataRowComparer(dataField))
            .ToList().ForEach(x => table.ImportRow(x));
        return table;
    }

    protected void RadGrid1_FilterCheckListItemsRequested(object sender, GridFilterCheckListItemsRequestedEventArgs e)
    {
        string DataField = (e.Column as IGridDataColumn).GetActiveDataField();

        e.ListBox.DataSource = GetListBoxSource(DataField);
        e.ListBox.DataKeyField = DataField;
        e.ListBox.DataTextField = DataField;
        e.ListBox.DataValueField = DataField;
        e.ListBox.DataBind();
    }
}